#include <Windows.h>
#include <stdio.h>
#include <TCHAR.h>

int main(int argc, char* argv[])
{
	int len = GetLogicalDriveStrings(0, 0);

	TCHAR *lpBuffer = (TCHAR *)malloc((len+1)*sizeof(TCHAR));
	if (!GetLogicalDriveStrings(len, lpBuffer))
	{
		_tprintf(_T("Call to GetLogicalDriveStrings failed.\n"));
	}
	else
	{
		// Iterate over strings in buffer
		TCHAR *pDrive = lpBuffer;
		while (*pDrive)
		{
			_tprintf(_T("%s\n"), pDrive);

			size_t driveLen = _tcslen(pDrive);
			// Drive + null char
			pDrive += driveLen + 1;
		}
	}

	free(lpBuffer);

	return 0;
}
